<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <style type="text/css">
        h2 {
            padding-right: 12px;
            padding-left: 12px;
        }

        h3 {
            padding-right: 12px;
            padding-left: 12px;
        }

        p {
            padding-right: 12px;
            padding-left: 12px;
        }

        body {
            word-break: break-all;
        }

        .label {
            font-weight: bold;
        }

    </style>

</head>
<body>
<h2 align="center">OPEN SOURCE SOFTWARE NOTICE</h2>
<p>Please note we provide an open source software notice along with this product and/or this product firmware (in the
    following just "this product"). The open source software licenses are granted by the respective right holders. And
    the open source licenses prevail all other license information with regard to the respective open source software
    contained in the product, including but not limited to End User Software Licensing Agreement. This notice is
    provided on behalf of Huawei Technologies Co. Ltd. and any of its local subsidiaries which may have provided this
    product to you in your local country.</p>
<h2>Warranty Disclaimer</h2>
<p><strong>THE OPEN SOURCE SOFTWARE IN THIS PRODUCT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY
    WARRANTY, WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE
    APPLICABLE LICENSES FOR MORE DETAILS.</strong></p>
<h2>Copyright Notice and License Texts </h2>

<h3>Software: Android Jetpack 2.2.1</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright (C) 2017 The Android Open Source Project<br/>
    <strong>License: Apache License V2.0</strong><br/>
<p id="apache">Apache License</p>
<p>Version 2.0, January 2004</p>
<p>http://www.apache.org/licenses/</p>
<p>TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION</p>
<p>1. Definitions.</p>
<p>&quot;License&quot; shall mean the terms and conditions for use, reproduction,
    and distribution as defined by Sections 1 through 9 of this document.</p>
<p>&quot;Licensor&quot; shall mean the copyright owner or entity authorized by
    the copyright owner that is granting the License.</p>
<p>&quot;Legal Entity&quot; shall mean the union of the acting entity and all
    other entities that control, are controlled by, or are under common
    control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or
    indirect, to cause the
    direction or management of such entity, whether by contract or
    otherwise, or (ii) ownership of fifty percent (50%) or more of the
    outstanding shares, or (iii) beneficial ownership of such entity.</p>
<p>&quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity
    exercising permissions granted by this License.</p>
<p>&quot;Source&quot; form shall mean the preferred form for making modifications,
    including but not limited to software source code, documentation
    source, and configuration files.</p>
<p>&quot;Object&quot; form shall mean any form resulting from mechanical
    transformation or translation of a Source form, including but
    not limited to compiled object code, generated documentation,
    and conversions to other media types.</p>
<p>&quot;Work&quot; shall mean the work of authorship, whether in Source or
    Object form, made available under the License, as indicated by a
    copyright notice that is included in or attached to the work
    (an example is provided in the Appendix below).</p>
<p>&quot;Derivative Works&quot; shall mean any work, whether in Source or Object
    form, that is based on (or derived from) the Work and for which the
    editorial revisions, annotations, elaborations, or other modifications
    represent, as a whole, an original work of authorship. For the purposes
    of this License, Derivative Works shall not include works that remain
    separable from, or merely link (or bind by name) to the interfaces of,
    the Work and Derivative Works thereof.</p>
<p>&quot;Contribution&quot; shall mean any work of authorship, including
    the original version of the Work and any modifications or additions
    to that Work or Derivative Works thereof, that is intentionally
    submitted to Licensor for inclusion in the Work by the copyright owner
    or by an individual or Legal Entity authorized to submit on behalf of
    the copyright owner. For the purposes of this definition, &quot;submitted&quot;
    means any form of electronic, verbal, or written communication sent
    to the Licensor or its representatives, including but not limited to
    communication on electronic mailing lists, source code control systems,
    and issue tracking systems that are managed by, or on behalf of, the
    Licensor for the purpose of discussing and improving the Work, but
    excluding communication that is conspicuously marked or otherwise
    designated in writing by the copyright owner as &quot;Not a Contribution.&quot;</p>
<p>&quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity
    on behalf of whom a Contribution has been received by Licensor and
    subsequently incorporated within the Work.</p>
<p>2. Grant of Copyright License. Subject to the terms and conditions of
    this License, each Contributor hereby grants to You a perpetual,
    worldwide, non-exclusive, no-charge, royalty-free, irrevocable
    copyright license to reproduce, prepare Derivative Works of,
    publicly display, publicly perform, sublicense, and distribute the
    Work and such Derivative Works in Source or Object form.</p>
<p>3. Grant of Patent License. Subject to the terms and conditions of
    this License, each Contributor hereby grants to You a perpetual,
    worldwide, non-exclusive, no-charge, royalty-free, irrevocable
    (except as stated in this section) patent license to make, have made,
    use, offer to sell, sell, import, and otherwise transfer the Work,
    where such license applies only to those patent claims licensable
    by such Contributor that are necessarily infringed by their
    Contribution(s) alone or by combination of their Contribution(s)
    with the Work to which such Contribution(s) was submitted. If You
    institute patent litigation against any entity (including a
    cross-claim or counterclaim in a lawsuit) alleging that the Work
    or a Contribution incorporated within the Work constitutes direct
    or contributory patent infringement, then any patent licenses
    granted to You under this License for that Work shall terminate
    as of the date such litigation is filed.</p>
<p>4. Redistribution. You may reproduce and distribute copies of the
    Work or Derivative Works thereof in any medium, with or without
    modifications, and in Source or Object form, provided that You
    meet the following conditions:</p>
<p> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;You must give any other recipients of the Work or
    Derivative Works a copy of this License; and<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;You must cause any modified files to carry prominent notices
    stating that You changed the files; and<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;You must retain, in the Source form of any Derivative Works
    that You distribute, all copyright, patent, trademark, and
    attribution notices from the Source form of the Work,
    excluding those notices that do not pertain to any part of
    the Derivative Works; and<br/>
    If the Work includes a &quot;NOTICE&quot; text file as part of its
    distribution, then any Derivative Works that You distribute must
    include a readable copy of the attribution notices contained
    within such NOTICE file, excluding those notices that do not
    pertain to any part of the Derivative Works, in at least one
    of the following places: within a NOTICE text file distributed
    as part of the Derivative Works; within the Source form or
    documentation, if provided along with the Derivative Works; or,
    within a display generated by the Derivative Works, if and
    wherever such third-party notices normally appear. The contents
    of the NOTICE file are for informational purposes only and
    do not modify the License. You may add Your own attribution
    notices within Derivative Works that You distribute, alongside
    or as an addendum to the NOTICE text from the Work, provided
    that such additional attribution notices cannot be construed
    as modifying the License.</p>
<p> You may add Your own copyright statement to Your modifications and
    may provide additional or different license terms and conditions
    for use, reproduction, or distribution of Your modifications, or
    for any such Derivative Works as a whole, provided Your use,
    reproduction, and distribution of the Work otherwise complies with
    the conditions stated in this License.</p>
<p>5. Submission of Contributions. Unless You explicitly state otherwise,
    any Contribution intentionally submitted for inclusion in the Work
    by You to the Licensor shall be under the terms and conditions of
    this License, without any additional terms or conditions.
    Notwithstanding the above, nothing herein shall supersede or modify
    the terms of any separate license agreement you may have executed
    with Licensor regarding such Contributions.</p>
<p>6. Trademarks. This License does not grant permission to use the trade
    names, trademarks, service marks, or product names of the Licensor,
    except as required for reasonable and customary use in describing the
    origin of the Work and reproducing the content of the NOTICE file.</p>
<p>7. Disclaimer of Warranty. Unless required by applicable law or
    agreed to in writing, Licensor provides the Work (and each
    Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
    implied, including, without limitation, any warranties or conditions
    of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
    PARTICULAR PURPOSE. You are solely responsible for determining the
    appropriateness of using or redistributing the Work and assume any
    risks associated with Your exercise of permissions under this License.</p>
<p>8. Limitation of Liability. In no event and under no legal theory,
    whether in tort (including negligence), contract, or otherwise,
    unless required by applicable law (such as deliberate and grossly
    negligent acts) or agreed to in writing, shall any Contributor be
    liable to You for damages, including any direct, indirect, special,
    incidental, or consequential damages of any character arising as a
    result of this License or out of the use or inability to use the
    Work (including but not limited to damages for loss of goodwill,
    work stoppage, computer failure or malfunction, or any and all
    other commercial damages or losses), even if such Contributor
    has been advised of the possibility of such damages.</p>
<p>9. Accepting Warranty or Additional Liability. While redistributing
    the Work or Derivative Works thereof, You may choose to offer,
    and charge a fee for, acceptance of support, warranty, indemnity,
    or other liability obligations and/or rights consistent with this
    License. However, in accepting such obligations, You may act only
    on Your own behalf and on Your sole responsibility, not on behalf
    of any other Contributor, and only if You agree to indemnify,
    defend, and hold each Contributor harmless for any liability
    incurred by, or claims asserted against, such Contributor by reason
    of your accepting any such warranty or additional liability.</p>
<p>END OF TERMS AND CONDITIONS<br/>
    APPENDIX: How to apply the Apache License to your work.</p>
<p>To apply the Apache License to your work, attach the following
    boilerplate notice, with the fields enclosed by brackets &quot;[]&quot;
    replaced with your own identifying information. (Don't include
    the brackets!) The text should be enclosed in the appropriate
    comment syntax for the file format. We also recommend that a
    file or class name and description of purpose be included on the
    same &quot;printed page&quot; as the copyright notice for easier
    identification within third-party archives.</p>
<p>Copyright [yyyy] [name of copyright owner]</p>
<p>Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);<br/>
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at</p>
<p>http://www.apache.org/licenses/LICENSE-2.0</p>
<p>Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an &quot;AS IS&quot; BASIS,<br/>
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.</p>
</p>

<h3>Software: AndroidX Annotation 1.2.0</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright (C) 2020 The Android Open Source Project<br/>
    Copyright (C) 2019 The Android Open Source Project<br/>
    Copyright (C) 2018 The Android Open Source Project<br/>
    Copyright (C) 2017 The Android Open Source Project<br/>
    Copyright (C) 2016 The Android Open Source Project<br/>
    Copyright (C) 2015 The Android Open Source Project<br/>
    Copyright (C) 2014 The Android Open Source Project<br/>
    Copyright (C) 2013 The Android Open Source Project<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
</p>

<h3>Software: EventBus 3.3.1</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright 2015 the original author or authors<br/>
    Copyright (c) 2012-2021 Markus Junginger, greenrobot (https://greenrobot.org)<br/>
    Copyright (c) 2012-2020 https://greenrobot.org'> greenrobot.org<br/>
    Copyright (c) 2012-2016 Markus Junginger, greenrobot (http://greenrobot.org)<br/>
    Copyright (c) 2012-2020 Markus Junginger, greenrobot (http://greenrobot.org)<br/>
    Copyright (c) 2015-2020 https://greenrobot.org'> greenrobot.org<br/>
    Copyright (c) 2012-2017 Markus Junginger, greenrobot (http://greenrobot.org)<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
</p>

<h3>Software: gson 2.9.0</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright 2008 Google Inc.<br/>
    Copyright (c) 2012 Square, Inc.<br/>
    Copyright (c) 2012 Google Inc.<br/>
    Copyright (c) 2011 Google Inc.<br/>
    Copyright (c) 2016 Gson<br/>
    Copyright 2008-2011 Google Inc.<br/>
    Copyright (c) 2008 Google Inc.<br/>
    Copyright (c) 2009 Google Inc.<br/>
    Copyright (c) 2010 Google Inc.<br/>
    Copyright (c) 2021 Google Inc.<br/>
    Copyright (c) 2014 Google Inc.<br/>
    Copyright (c) 2017 The Gson authors<br/>
    Copyright (c) 2010 The Android Open Source Project<br/>
    Copyright (c) 2020 Google Inc.<br/>
    Copyright (c) 2018 The Gson authors<br/>
    Copyright (c) 2016 The Gson Authors<br/>
    Copyright (c) 2018 Gson<br/>
    Copyright (c) 2015 Google Inc.<br/>
    Copyright (c) 2016 Google Inc.<br/>
    Copyright (c) 2017 Google Inc.<br/>
    Copyright (c) 2017 Gson<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
</p>

<h3>Software: retrofit 2.9.0</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright (c) 2012 Square, Inc.<br/>
    Copyright (c) 2013 Square, Inc.<br/>
    Copyright (c) 2014 Square, Inc.<br/>
    Copyright (c) 2019 Square, Inc.<br/>
    Copyright (c) 2018 Square, Inc.<br/>
    Copyright 2014 Square, Inc.<br/>
    Copyright (c) 2015 Square, Inc.<br/>
    Copyright (c) 2017 Square, Inc.<br/>
    Copyright (c) 2008 Google Inc.<br/>
    Copyright (c) 2011 Square, Inc.<br/>
    Copyright (c) 2016 Square, Inc.<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
</p>

<h3>The Legion of the Bouncy Castle 1.74</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright 2015 the original author or authors<br/>
    Copyright (c) 2000-2023 The Legion of the Bouncy Castle Inc. (https://www.bouncycastle.org)<br/>
    Copyright (c) 2000-2023 The Legion Of The Bouncy Castle Inc. (https://www.bouncycastle.org)<br/>
    Copyright Dr B. R Gladman (gladman@seven77.demon.co.uk) and Sam Simpson (s.simpson@mia.co.uk)<br/>
    Copyright (c) 2001 Company<br/>
    Copyright (c) 2011 Tim Buktu (tbuktu@hotmail.com)<br/>
    Copyright 1997-2007 Sun Microsystems, Inc.<br/>
    Copyright (c) 1989, 1991 Free Software Foundation, Inc.<br/>
    Copyright (c) 1997, 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 1997, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2018 Oracle and/or its affiliates<br/>
    Copyright (c) 2021 Oracle and/or its affiliates<br/>
    Copyright (c) 2005, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2014, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 1997, 2018 Oracle and/or its affiliates<br/>
    Copyright (c) 1997, 2021 Oracle and/or its affiliates<br/>
    Copyright (c) 2014, 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 2010, 2018 Oracle and/or its affiliates<br/>
    Copyright (c) 2010, 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2008, 2018 Oracle and/or its affiliates<br/>
    Copyright (c) 2012, 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 2013, 2021 Oracle and/or its affiliates<br/>
    Copyright (c) 2013, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2013, 2019 Jason Mehrens<br/>
    Copyright (c) 2015, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2015, 2018 Jason Mehrens<br/>
    Copyright (c) 2009, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 2009, 2019 Jason Mehrens<br/>
    Copyright (c) 2009, 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 2009, 2020 Jason Mehrens<br/>
    Copyright (c) 2009, 2018 Jason Mehrens<br/>
    Copyright (c) 2013, 2018 Oracle and/or its affiliates<br/>
    Copyright (c) 2013, 2018 Jason Mehrens<br/>
    Copyright (c) 2020 Oracle and/or its affiliates<br/>
    Copyright (c) 2018 Eclipse Foundation<br/>
    Copyright (c) 2010, 2019 Oracle and/or its affiliates<br/>
    Copyright (c) 1997-2012 Oracle and/or its affiliates<br/>
    Copyright (c) 1997-2011 Oracle and/or its affiliates<br/>
    Copyright (c) 2005-2010 Oracle and/or its affiliates<br/>
    Copyright (c) 2005-2012 Oracle and/or its affiliates<br/>
    Copyright (c) 1997-2010 Oracle and/or its affiliates<br/>
    Copyright (c) 1997-2013 Oracle and/or its affiliates<br/>
    Copyright (c) 2010-2011 Oracle and/or its affiliates<br/>
    Copyright (c) 2008-2012 Oracle and/or its affiliates<br/>
    Copyright (c) 2012 Oracle and/or its affiliates<br/>
    Copyright (c) 2009-2012 Oracle and/or its affiliates<br/>
    Copyright (c) 2009-2012 Jason Mehrens<br/>
    Copyright (c) 2009-2010 Oracle and/or its affiliates<br/>
    Copyright (c) 2009-2010 Jason Mehrens<br/>
    Copyright (c) 2010 Oracle and/or its affiliates<br/>
    Copyright 2008-2023 Ping Identity Corporation<br/>
    Copyright (c) 2008-2023 Ping Identity Corporation<br/>
    Copyright 2017-2023 Ping Identity Corporation<br/>
    Copyright (c) 2017-2023 Ping Identity Corporation<br/>
    Copyright 2014-2023 Ping Identity Corporation<br/>
    Copyright (c) 2014-2023 Ping Identity Corporation<br/>
    Copyright 2009-2023 Ping Identity Corporation<br/>
    Copyright (c) 2009-2023 Ping Identity Corporation<br/>
    Copyright 2015-2023 Ping Identity Corporation<br/>
    Copyright (c) 2015-2023 Ping Identity Corporation<br/>
    Copyright 2010-2023 Ping Identity Corporation<br/>
    Copyright (c) 2010-2023 Ping Identity Corporation<br/>
    Copyright 2016-2023 Ping Identity Corporation<br/>
    Copyright (c) 2016-2023 Ping Identity Corporation<br/>
    Copyright 2007-2023 Ping Identity Corporation<br/>
    Copyright (c) 2007-2023 Ping Identity Corporation<br/>
    Copyright 2023 Ping Identity Corporation<br/>
    Copyright 2020-2023 Ping Identity Corporation<br/>
    Copyright (c) 2023 Ping Identity Corporation<br/>
    Copyright 2011-2023 Ping Identity Corporation<br/>
    Copyright (c) 2011-2023 Ping Identity Corporation<br/>
    Copyright (c) 2020-2023 Ping Identity Corporation<br/>
    Copyright 2019-2023 Ping Identity Corporation<br/>
    Copyright (c) 2019-2023 Ping Identity Corporation<br/>
    Copyright 2022-2023 Ping Identity Corporation<br/>
    Copyright (c) 2022-2023 Ping Identity Corporation<br/>
    Copyright 2013-2023 Ping Identity Corporation<br/>
    Copyright (c) 2013-2023 Ping Identity Corporation<br/>
    Copyright 2021-2023 Ping Identity Corporation<br/>
    Copyright (c) 2021-2023 Ping Identity Corporation<br/>
    Copyright 2012-2023 Ping Identity Corporation<br/>
    Copyright (c) 2012-2023 Ping Identity Corporation<br/>
    Copyright 2018-2023 Ping Identity Corporation<br/>
    Copyright (c) 2018-2023 Ping Identity Corporation<br/>
    Copyright (c) 1991, 1999 Free Software Foundation, Inc.<br/>
    Copyright 2008-2023 Ping Identity Corporation Bundle-Name UnboundID LDAP<br/>
    Copyright (c) 2005 The Legion Of The Bouncy Castle (https://www.bouncycastle.org)<br/>
    (c) 2006 VeriSign, Inc.<br/>
    Copyright 2011, Cisco Systems, Inc<br/>
    Copyright (c) 2007 Timothy Wall<br/>
    Copyright (c) 2007 Wayne Meissner<br/>
    Copyright (c) 2007-2013 Timothy Wall<br/>
    Copyright (c) 2011 Timothy Wall<br/>
    Copyright (c) 2009 Timothy Wall<br/>
    Copyright (c) 2007-2015 Timothy Wall<br/>
    Copyright 2007 Timothy Wall<br/>
    Copyright (c) 2007-2008 Timothy Wall<br/>
    Copyright (c) 2007-2012 Timothy Wall<br/>
    Copyright (c) 2012 Timothy Wall<br/>
    Copyright 2008-2016 Timothy Wall<br/>
    Copyright (c) 2015 Andreas PAX L u00FCck<br/>
    Copyright 2014 Martin Steiger<br/>
    Copyright (c) 2010 Timothy Wall<br/>
    Copyright (c) 2007 Olivier Chafik<br/>
    Copyright (c) 2008 Timothy Wall<br/>
    Parts Copyright (c) 2007 Olivier Chafik<br/>
    Copyright (c) 2011 Denis Tulskiy<br/>
    Copyright (c) 2015 Daniel Widdis<br/>
    Copyright (c) 2014 Reinhard Pointner<br/>
    Copyright (c) 2015 Goldstein Lyor<br/>
    Copyright (c) 2015 Adam Marcionek<br/>
    Copyright (c) 2010 Daniel Doubrovkine<br/>
    Copyright (c) 2012 Tobias Wolf<br/>
    copyright (c) 2007 Timothy Wall<br/>
    Copyright (c) 2015 Michael Freeman<br/>
    Copyright (c) 2007, 2013 Timothy Wall, Markus Karg<br/>
    Copyright (c) 2010, 2013 Daniel Doubrovkine, Markus Karg<br/>
    Copyright (c) 2016 Adam Marcionek<br/>
    Copyright 2010 Digital Rapids Corp.<br/>
    Copyright (c) 2013 Ralf Hamberger, Markus Karg<br/>
    Copyright (c) 2010,2011 Daniel Doubrovkine<br/>
    Copyright (c) 2010 EugineLev<br/>
    Copyright (c) 2016 Minoru Sakamoto<br/>
    Copyright 2002-2004 Apache Software Foundation<br/>
    Copyright (c) 2011 Daniel Doubrovkine<br/>
    Copyright (c) 2013 Tobias Wolf<br/>
    Copyright (c) 2014 Dr David H. Akehurst (itemis)<br/>
    <strong>License: The MIT License</strong><br/>
<p id="mit">The MIT License</p>
<p>Copyright (c) &lt;year&gt; &lt;copyright holders&gt;</p>
<p>Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the &quot;Software&quot;), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:</p>
<p>The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.</p>
<p>THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    THE SOFTWARE.</p>
</p>

<h3>Software: fastjson 1.2.83</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright 1999-2017 Alibaba Group<br/>
    Copyright (c) 2000-2007 INRIA, France Telecom<br/>
    Copyright 1999-2100 Alibaba.com Corporation Limited<br/>
    Copyright 2018 Diffblue Limited<br/>
    Copyright 1999-2020 Alibaba Group Holding Ltd.<br/>
    Copyright 2016 Dark Phoenixs<br/>
    Copyright 1999-2018 Alibaba Group<br/>
    Copyright (c) 2014 www.yiji.com Inc.<br/>
    copyright 2009, Scooby<br/>
    Copyright 1999-2019 Alibaba Group<br/>
    Copyright 2015-2016 Dark Phoenixs<br/>
    Copyright 2015 Alibaba.com<br/>
    Copyright (c) 2003-2012 Taobao.com Inc.<br/>
    Copyright 2008 Alibaba.com Croporation Limited<br/>
    Copyright 1999-2019 Alibaba Group Holding Ltd.<br/>
    Copyright 2008 Alibaba.com Corporation Limited<br/>
    Copyright 2019 thunisoft, Inc.<br/>
    Copyright Set 2009, Scooby Doo<br/>
    Copyright (c) 2004, Mikael Grev, MiG InfoCom AB. (base64 miginfocom . com)<br/>
    Copyright 1999-2004 Alibaba.com<br/>
    Copyright 2011 Alibaba.com<br/>
    Copyright (c) The Internet Society (2006)<br/>
    Copyright 2018 Ulf Adams<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
    <strong>License: BSD 3-Clause License</strong><br/>
<p id="bsd">BSD 3-Clause License</p>
<p>Copyright (c) 2014, ESnet</p>
<p>All rights reserved.</p>
<p>Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
    following conditions are met:</p>
<p>1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following
    disclaimer.</p>
<p>2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the
    following disclaimer in the documentation and/or other materials provided with the distribution.</p>
<p>3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote
    products derived from this software without specific prior written permission.</p>
<p>THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</p>
</p>

<h3>Software: greenDao 3.3.0</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright (C) 2011-2016 Markus Junginger, greenrobot (http://greenrobot.org)<br/>
    Copyright 2011-2016 by Markus Junginger / greenrobot.org<br/>
    Copyright (C) 2011 Markus Junginger, greenrobot (http://greenrobot.de)<br/>
    Copyright (C) 2011-2015 Markus Junginger, greenrobot (http://greenrobot.de)<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
    <strong>License: GPL V3.0</strong><br/>
<p id="lgpl3">GNU LESSER GENERAL PUBLIC LICENSE
    Version 3, 29 June 2007</p>

<p>Copyright (C) 2007 Free Software Foundation, Inc.
    <http:
    //fsf.org/>
</p>

<p>Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not
    allowed.</p>

<p>This version of the GNU Lesser General Public License incorporates the terms and conditions of version 3 of the GNU
    General Public License, supplemented by the additional permissions listed below.</p>

<p>0. Additional Definitions.</p>
<p>As used herein, “this License” refers to version 3 of the GNU Lesser General Public License, and the “GNU GPL” refers
    to version 3 of the GNU General Public License.</p>

<p>“The Library” refers to a covered work governed by this License, other than an Application or a Combined Work as
    defined below.</p>

<p>An “Application” is any work that makes use of an interface provided by the Library, but which is not otherwise based
    on the Library. Defining a subclass of a class defined by the Library is deemed a mode of using an interface
    provided by the Library.</p>

<p>A “Combined Work” is a work produced by combining or linking an Application with the Library. The particular version
    of the Library with which the Combined Work was made is also called the “Linked Version”.</p>

<p>The “Minimal Corresponding Source” for a Combined Work means the Corresponding Source for the Combined Work,
    excluding any source code for portions of the Combined Work that, considered in isolation, are based on the
    Application, and not on the Linked Version.</p>

<p>The “Corresponding Application Code” for a Combined Work means the object code and/or source code for the
    Application, including any data and utility programs needed for reproducing the Combined Work from the Application,
    but excluding the System Libraries of the Combined Work.</p>

<p>1. Exception to Section 3 of the GNU GPL.</p>
<p>You may convey a covered work under sections 3 and 4 of this License without being bound by section 3 of the GNU
    GPL.</p>

<p>2. Conveying Modified Versions.</p>
<p>If you modify a copy of the Library, and, in your modifications, a facility refers to a function or data to be
    supplied by an Application that uses the facility (other than as an argument passed when the facility is invoked),
    then you may convey a copy of the modified version:</p>

<p>a) under this License, provided that you make a good faith effort to ensure that, in the event an Application does
    not supply the function or data, the facility still operates, and performs whatever part of its purpose remains
    meaningful, or</p>
<p>b) under the GNU GPL, with none of the additional permissions of this License applicable to that copy.</p>
<p>3. Object Code Incorporating Material from Library Header Files.</p>
<p>The object code form of an Application may incorporate material from a header file that is part of the Library. You
    may convey such object code under terms of your choice, provided that, if the incorporated material is not limited
    to numerical parameters, data structure layouts and accessors, or small macros, inline functions and templates (ten
    or fewer lines in length), you do both of the following:</p>

<p>a) Give prominent notice with each copy of the object code that the Library is used in it and that the Library and
    its use are covered by this License.</p>
<p>b) Accompany the object code with a copy of the GNU GPL and this license document.</p>
<p>4. Combined Works.</p>
<p>You may convey a Combined Work under terms of your choice that, taken together, effectively do not restrict
    modification of the portions of the Library contained in the Combined Work and reverse engineering for debugging
    such modifications, if you also do each of the following:</p>

<p>a) Give prominent notice with each copy of the Combined Work that the Library is used in it and that the Library and
    its use are covered by this License.</p>
<p>b) Accompany the Combined Work with a copy of the GNU GPL and this license document.</p>
<p>c) For a Combined Work that displays copyright notices during execution, include the copyright notice for the Library
    among these notices, as well as a reference directing the user to the copies of the GNU GPL and this license
    document.</p>
<p>d) Do one of the following:</p>
<p>0) Convey the Minimal Corresponding Source under the terms of this License, and the Corresponding Application Code in
    a form suitable for, and under terms that permit, the user to recombine or relink the Application with a modified
    version of the Linked Version to produce a modified Combined Work, in the manner specified by section 6 of the GNU
    GPL for conveying Corresponding Source.</p>
<p>1) Use a suitable shared library mechanism for linking with the Library. A suitable mechanism is one that (a) uses at
    run time a copy of the Library already present on the user's computer system, and (b) will operate properly with a
    modified version of the Library that is interface-compatible with the Linked Version.</p>
<p>e) Provide Installation Information, but only if you would otherwise be required to provide such information under
    section 6 of the GNU GPL, and only to the extent that such information is necessary to install and execute a
    modified version of the Combined Work produced by recombining or relinking the Application with a modified version
    of the Linked Version. (If you use option 4d0, the Installation Information must accompany the Minimal Corresponding
    Source and Corresponding Application Code. If you use option 4d1, you must provide the Installation Information in
    the manner specified by section 6 of the GNU GPL for conveying Corresponding Source.)</p>
<p>5. Combined Libraries.</p>
<p>You may place library facilities that are a work based on the Library side by side in a single library together with
    other library facilities that are not Applications and are not covered by this License, and convey such a combined
    library under terms of your choice, if you do both of the following:</p>

<p>a) Accompany the combined library with a copy of the same work based on the Library, uncombined with any other
    library facilities, conveyed under the terms of this License.</p>
<p>b) Give prominent notice with the combined library that part of it is a work based on the Library, and explaining
    where to find the accompanying uncombined form of the same work.</p>
<p>6. Revised Versions of the GNU Lesser General Public License.</p>
<p>The Free Software Foundation may publish revised and/or new versions of the GNU Lesser General Public License from
    time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to
    address new problems or concerns.</p>

<p>Each version is given a distinguishing version number. If the Library as you received it specifies that a certain
    numbered version of the GNU Lesser General Public License “or any later version” applies to it, you have the option
    of following the terms and conditions either of that published version or of any later version published by the Free
    Software Foundation. If the Library as you received it does not specify a version number of the GNU Lesser General
    Public License, you may choose any version of the GNU Lesser General Public License ever published by the Free
    Software Foundation.</p>

<p>If the Library as you received it specifies that a proxy can decide whether future versions of the GNU Lesser General
    Public License shall apply, that proxy's public statement of acceptance of any version is permanent authorization
    for you to choose that version for the Library.</p>

<p>GNU GENERAL PUBLIC LICENSE</p>
<p>Version 3, 29 June 2007</p>

<p>Copyright (C) 2007 Free Software Foundation, Inc.
    <http:
    //fsf.org/>
</p>

<p>Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not
    allowed.</p>

<p>Preamble</p>
<p>The GNU General Public License is a free, copyleft license for software and other kinds of works.</p>

<p>The licenses for most software and other practical works are designed to take away your freedom to share and change
    the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all
    versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation,
    use the GNU General Public License for most of our software; it applies also to any other work released this way by
    its authors. You can apply it to your programs, too.</p>

<p>When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to
    make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that
    you receive source code or can get it if you want it, that you can change the software or use pieces of it in new
    free programs, and that you know you can do these things.</p>

<p>To protect your rights, we need to prevent others from denying you these rights or asking you to surrender the
    rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it:
    responsibilities to respect the freedom of others.</p>

<p>For example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the
    recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source
    code. And you must show them these terms so they know their rights.</p>

<p>Developers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2)
    offer you this License giving you legal permission to copy, distribute and/or modify it.</p>

<p>For the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free
    software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that
    their problems will not be attributed erroneously to authors of previous versions.</p>

<p>Some devices are designed to deny users access to install or run modified versions of the software inside them,
    although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to
    change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use,
    which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit
    the practice for those products. If such problems arise substantially in other domains, we stand ready to extend
    this provision to those domains in future versions of the GPL, as needed to protect the freedom of users.</p>

<p>Finally, every program is threatened constantly by software patents. States should not allow patents to restrict
    development and use of software on general-purpose computers, but in those that do, we wish to avoid the special
    danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL
    assures that patents cannot be used to render the program non-free.</p>

<p>The precise terms and conditions for copying, distribution and modification follow.</p>

<p>TERMS AND CONDITIONS</p>
<p>0. Definitions.</p>
<p>“This License” refers to version 3 of the GNU General Public License.</p>

<p>“Copyright” also means copyright-like laws that apply to other kinds of works, such as semiconductor masks.</p>

<p>“The Program” refers to any copyrightable work licensed under this License. Each licensee is addressed as “you”.
    “Licensees” and “recipients” may be individuals or organizations.</p>

<p>To “modify” a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission,
    other than the making of an exact copy. The resulting work is called a “modified version” of the earlier work or a
    work “based on” the earlier work.</p>

<p>A “covered work” means either the unmodified Program or a work based on the Program.</p>

<p>To “propagate” a work means to do anything with it that, without permission, would make you directly or secondarily
    liable for infringement under applicable copyright law, except executing it on a computer or modifying a private
    copy. Propagation includes copying, distribution (with or without modification), making available to the public, and
    in some countries other activities as well.</p>

<p>To “convey” a work means any kind of propagation that enables other parties to make or receive copies. Mere
    interaction with a user through a computer network, with no transfer of a copy, is not conveying.</p>

<p>An interactive user interface displays “Appropriate Legal Notices” to the extent that it includes a convenient and
    prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is
    no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work
    under this License, and how to view a copy of this License. If the interface presents a list of user commands or
    options, such as a menu, a prominent item in the list meets this criterion.</p>

<p>1. Source Code.</p>
<p>The “source code” for a work means the preferred form of the work for making modifications to it. “Object code” means
    any non-source form of a work.</p>

<p>A “Standard Interface” means an interface that either is an official standard defined by a recognized standards body,
    or, in the case of interfaces specified for a particular programming language, one that is widely used among
    developers working in that language.</p>

<p>The “System Libraries” of an executable work include anything, other than the work as a whole, that (a) is included
    in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves
    only to enable use of the work with that Major Component, or to implement a Standard Interface for which an
    implementation is available to the public in source code form. A “Major Component”, in this context, means a major
    essential component (kernel, window system, and so on) of the specific operating system (if any) on which the
    executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it.</p>

<p>The “Corresponding Source” for a work in object code form means all the source code needed to generate, install, and
    (for an executable work) run the object code and to modify the work, including scripts to control those activities.
    However, it does not include the work's System Libraries, or general-purpose tools or generally available free
    programs which are used unmodified in performing those activities but which are not part of the work. For example,
    Corresponding Source includes interface definition files associated with source files for the work, and the source
    code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such
    as by intimate data communication or control flow between those subprograms and other parts of the work.</p>

<p>The Corresponding Source need not include anything that users can regenerate automatically from other parts of the
    Corresponding Source.</p>

<p>The Corresponding Source for a work in source code form is that same work.</p>

<p>2. Basic Permissions.</p>
<p>All rights granted under this License are granted for the term of copyright on the Program, and are irrevocable
    provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the
    unmodified Program. The output from running a covered work is covered by this License only if the output, given its
    content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as
    provided by copyright law.</p>

<p>You may make, run and propagate covered works that you do not convey, without conditions so long as your license
    otherwise remains in force. You may convey covered works to others for the sole purpose of having them make
    modifications exclusively for you, or provide you with facilities for running those works, provided that you comply
    with the terms of this License in conveying all material for which you do not control copyright. Those thus making
    or running the covered works for you must do so exclusively on your behalf, under your direction and control, on
    terms that prohibit them from making any copies of your copyrighted material outside their relationship with
    you.</p>

<p>Conveying under any other circumstances is permitted solely under the conditions stated below. Sublicensing is not
    allowed; section 10 makes it unnecessary.</p>

<p>3. Protecting Users' Legal Rights From Anti-Circumvention Law.</p>
<p>No covered work shall be deemed part of an effective technological measure under any applicable law fulfilling
    obligations under article 11 of the WIPO copyright treaty adopted on 20 December 1996, or similar laws prohibiting
    or restricting circumvention of such measures.</p>

<p>When you convey a covered work, you waive any legal power to forbid circumvention of technological measures to the
    extent such circumvention is effected by exercising rights under this License with respect to the covered work, and
    you disclaim any intention to limit operation or modification of the work as a means of enforcing, against the
    work's users, your or third parties' legal rights to forbid circumvention of technological measures.

<p>4. Conveying Verbatim Copies.</p>
<p>You may convey verbatim copies of the Program's source code as you receive it, in any medium, provided that you
    conspicuously and appropriately publish on each copy an appropriate copyright notice; keep intact all notices
    stating that this License and any non-permissive terms added in accord with section 7 apply to the code; keep intact
    all notices of the absence of any warranty; and give all recipients a copy of this License along with the
    Program.</p>

<p>You may charge any price or no price for each copy that you convey, and you may offer support or warranty protection
    for a fee.</p>

<p>5. Conveying Modified Source Versions.</p>
<p>You may convey a work based on the Program, or the modifications to produce it from the Program, in the form of
    source code under the terms of section 4, provided that you also meet all of these conditions:</p>

<p>a) The work must carry prominent notices stating that you modified it, and giving a relevant date.</p>
<p>b) The work must carry prominent notices stating that it is released under this License and any conditions added
    under section 7. This requirement modifies the requirement in section 4 to “keep intact all notices”.</p>
<p>c) You must license the entire work, as a whole, under this License to anyone who comes into possession of a copy.
    This License will therefore apply, along with any applicable section 7 additional terms, to the whole of the work,
    and all its parts, regardless of how they are packaged. This License gives no permission to license the work in any
    other way, but it does not invalidate such permission if you have separately received it.</p>
<p>d) If the work has interactive user interfaces, each must display Appropriate Legal Notices; however, if the Program
    has interactive interfaces that do not display Appropriate Legal Notices, your work need not make them do so.
<p>A compilation of a covered work with other separate and independent works, which are not by their nature extensions
    of the covered work, and which are not combined with it such as to form a larger program, in or on a volume of a
    storage or distribution medium, is called an “aggregate” if the compilation and its resulting copyright are not used
    to limit the access or legal rights of the compilation's users beyond what the individual works permit. Inclusion of
    a covered work in an aggregate does not cause this License to apply to the other parts of the aggregate.</p>

<p>6. Conveying Non-Source Forms.</p>
<p>You may convey a covered work in object code form under the terms of sections 4 and 5, provided that you also convey
    the machine-readable Corresponding Source under the terms of this License, in one of these ways:</p>

<p>a) Convey the object code in, or embodied in, a physical product (including a physical distribution medium),
    accompanied by the Corresponding Source fixed on a durable physical medium customarily used for software
    interchange.</p>
<p>b) Convey the object code in, or embodied in, a physical product (including a physical distribution medium),
    accompanied by a written offer, valid for at least three years and valid for as long as you offer spare parts or
    customer support for that product model, to give anyone who possesses the object code either (1) a copy of the
    Corresponding Source for all the software in the product that is covered by this License, on a durable physical
    medium customarily used for software interchange, for a price no more than your reasonable cost of physically
    performing this conveying of source, or (2) access to copy the Corresponding Source from a network server at no
    charge.</p>
<p>c) Convey individual copies of the object code with a copy of the written offer to provide the Corresponding Source.
    This alternative is allowed only occasionally and noncommercially, and only if you received the object code with
    such an offer, in accord with subsection 6b.</p>
<p>d) Convey the object code by offering access from a designated place (gratis or for a charge), and offer equivalent
    access to the Corresponding Source in the same way through the same place at no further charge. You need not require
    recipients to copy the Corresponding Source along with the object code. If the place to copy the object code is a
    network server, the Corresponding Source may be on a different server (operated by you or a third party) that
    supports equivalent copying facilities, provided you maintain clear directions next to the object code saying where
    to find the Corresponding Source. Regardless of what server hosts the Corresponding Source, you remain obligated to
    ensure that it is available for as long as needed to satisfy these requirements.</p>
<p>e) Convey the object code using peer-to-peer transmission, provided you inform other peers where the object code and
    Corresponding Source of the work are being offered to the general public at no charge under subsection 6d.</p>
<p>A separable portion of the object code, whose source code is excluded from the Corresponding Source as a System
    Library, need not be included in conveying the object code work.

<p>A “User Product” is either (1) a “consumer product”, which means any tangible personal property which is normally
    used for personal, family, or household purposes, or (2) anything designed or sold for incorporation into a
    dwelling. In determining whether a product is a consumer product, doubtful cases shall be resolved in favor of
    coverage. For a particular product received by a particular user, “normally used” refers to a typical or common use
    of that class of product, regardless of the status of the particular user or of the way in which the particular user
    actually uses, or expects or is expected to use, the product. A product is a consumer product regardless of whether
    the product has substantial commercial, industrial or non-consumer uses, unless such uses represent the only
    significant mode of use of the product.</p>

<p>“Installation Information” for a User Product means any methods, procedures, authorization keys, or other information
    required to install and execute modified versions of a covered work in that User Product from a modified version of
    its Corresponding Source. The information must suffice to ensure that the continued functioning of the modified
    object code is in no case prevented or interfered with solely because modification has been made.</p>

<p>If you convey an object code work under this section in, or with, or specifically for use in, a User Product, and the
    conveying occurs as part of a transaction in which the right of possession and use of the User Product is
    transferred to the recipient in perpetuity or for a fixed term (regardless of how the transaction is characterized),
    the Corresponding Source conveyed under this section must be accompanied by the Installation Information. But this
    requirement does not apply if neither you nor any third party retains the ability to install modified object code on
    the User Product (for example, the work has been installed in ROM).</p>

<p>The requirement to provide Installation Information does not include a requirement to continue to provide support
    service, warranty, or updates for a work that has been modified or installed by the recipient, or for the User
    Product in which it has been modified or installed. Access to a network may be denied when the modification itself
    materially and adversely affects the operation of the network or violates the rules and protocols for communication
    across the network.</p>

<p>Corresponding Source conveyed, and Installation Information provided, in accord with this section must be in a format
    that is publicly documented (and with an implementation available to the public in source code form), and must
    require no special password or key for unpacking, reading or copying.</p>

<p>7. Additional Terms.</p>
<p>“Additional permissions” are terms that supplement the terms of this License by making exceptions from one or more of
    its conditions. Additional permissions that are applicable to the entire Program shall be treated as though they
    were included in this License, to the extent that they are valid under applicable law. If additional permissions
    apply only to part of the Program, that part may be used separately under those permissions, but the entire Program
    remains governed by this License without regard to the additional permissions.</p>

<p>When you convey a copy of a covered work, you may at your option remove any additional permissions from that copy, or
    from any part of it. (Additional permissions may be written to require their own removal in certain cases when you
    modify the work.) You may place additional permissions on material, added by you to a covered work, for which you
    have or can give appropriate copyright permission.</p>

<p>Notwithstanding any other provision of this License, for material you add to a covered work, you may (if authorized
    by the copyright holders of that material) supplement the terms of this License with terms:</p>

<p>a) Disclaiming warranty or limiting liability differently from the terms of sections 15 and 16 of this License;
    or</p>
<p>b) Requiring preservation of specified reasonable legal notices or author attributions in that material or in the
    Appropriate Legal Notices displayed by works containing it; or</p>
<p>c) Prohibiting misrepresentation of the origin of that material, or requiring that modified versions of such material
    be marked in reasonable ways as different from the original version; or</p>
<p>d) Limiting the use for publicity purposes of names of licensors or authors of the material; or</p>
<p>e) Declining to grant rights under trademark law for use of some trade names, trademarks, or service marks; or</p>
<p>f) Requiring indemnification of licensors and authors of that material by anyone who conveys the material (or
    modified versions of it) with contractual assumptions of liability to the recipient, for any liability that these
    contractual assumptions directly impose on those licensors and authors.</p>
<p>All other non-permissive additional terms are considered “further restrictions” within the meaning of section 10. If
    the Program as you received it, or any part of it, contains a notice stating that it is governed by this License
    along with a term that is a further restriction, you may remove that term. If a license document contains a further
    restriction but permits relicensing or conveying under this License, you may add to a covered work material governed
    by the terms of that license document, provided that the further restriction does not survive such relicensing or
    conveying.</p>

<p>If you add terms to a covered work in accord with this section, you must place, in the relevant source files, a
    statement of the additional terms that apply to those files, or a notice indicating where to find the applicable
    terms.</p>

<p>Additional terms, permissive or non-permissive, may be stated in the form of a separately written license, or stated
    as exceptions; the above requirements apply either way.</p>

<p>8. Termination.</p>
<p>You may not propagate or modify a covered work except as expressly provided under this License. Any attempt otherwise
    to propagate or modify it is void, and will automatically terminate your rights under this License (including any
    patent licenses granted under the third paragraph of section 11).</p>

<p>However, if you cease all violation of this License, then your license from a particular copyright holder is
    reinstated (a) provisionally, unless and until the copyright holder explicitly and finally terminates your license,
    and (b) permanently, if the copyright holder fails to notify you of the violation by some reasonable means prior to
    60 days after the cessation.</p>

<p>Moreover, your license from a particular copyright holder is reinstated permanently if the copyright holder notifies
    you of the violation by some reasonable means, this is the first time you have received notice of violation of this
    License (for any work) from that copyright holder, and you cure the violation prior to 30 days after your receipt of
    the notice.</p>

<p>Termination of your rights under this section does not terminate the licenses of parties who have received copies or
    rights from you under this License. If your rights have been terminated and not permanently reinstated, you do not
    qualify to receive new licenses for the same material under section 10.</p>

<p>9. Acceptance Not Required for Having Copies.</p>
<p>You are not required to accept this License in order to receive or run a copy of the Program. Ancillary propagation
    of a covered work occurring solely as a consequence of using peer-to-peer transmission to receive a copy likewise
    does not require acceptance. However, nothing other than this License grants you permission to propagate or modify
    any covered work. These actions infringe copyright if you do not accept this License. Therefore, by modifying or
    propagating a covered work, you indicate your acceptance of this License to do so.</p>

<p>10. Automatic Licensing of Downstream Recipients.</p>
<p>Each time you convey a covered work, the recipient automatically receives a license from the original licensors, to
    run, modify and propagate that work, subject to this License. You are not responsible for enforcing compliance by
    third parties with this License.</p>

<p>An “entity transaction” is a transaction transferring control of an organization, or substantially all assets of one,
    or subdividing an organization, or merging organizations. If propagation of a covered work results from an entity
    transaction, each party to that transaction who receives a copy of the work also receives whatever licenses to the
    work the party's predecessor in interest had or could give under the previous paragraph, plus a right to possession
    of the Corresponding Source of the work from the predecessor in interest, if the predecessor has it or can get it
    with reasonable efforts.</p>

<p>You may not impose any further restrictions on the exercise of the rights granted or affirmed under this License. For
    example, you may not impose a license fee, royalty, or other charge for exercise of rights granted under this
    License, and you may not initiate litigation (including a cross-claim or counterclaim in a lawsuit) alleging that
    any patent claim is infringed by making, using, selling, offering for sale, or importing the Program or any portion
    of it.</p>

<p>11. Patents.</p>
<p>A “contributor” is a copyright holder who authorizes use under this License of the Program or a work on which the
    Program is based. The work thus licensed is called the contributor's “contributor version”.</p>

<p>A contributor's “essential patent claims” are all patent claims owned or controlled by the contributor, whether
    already acquired or hereafter acquired, that would be infringed by some manner, permitted by this License, of
    making, using, or selling its contributor version, but do not include claims that would be infringed only as a
    consequence of further modification of the contributor version. For purposes of this definition, “control” includes
    the right to grant patent sublicenses in a manner consistent with the requirements of this License.</p>

<p>Each contributor grants you a non-exclusive, worldwide, royalty-free patent license under the contributor's essential
    patent claims, to make, use, sell, offer for sale, import and otherwise run, modify and propagate the contents of
    its contributor version.</p>

<p>In the following three paragraphs, a “patent license” is any express agreement or commitment, however denominated,
    not to enforce a patent (such as an express permission to practice a patent or covenant not to sue for patent
    infringement). To “grant” such a patent license to a party means to make such an agreement or commitment not to
    enforce a patent against the party.</p>

<p>If you convey a covered work, knowingly relying on a patent license, and the Corresponding Source of the work is not
    available for anyone to copy, free of charge and under the terms of this License, through a publicly available
    network server or other readily accessible means, then you must either (1) cause the Corresponding Source to be so
    available, or (2) arrange to deprive yourself of the benefit of the patent license for this particular work, or (3)
    arrange, in a manner consistent with the requirements of this License, to extend the patent license to downstream
    recipients. “Knowingly relying” means you have actual knowledge that, but for the patent license, your conveying the
    covered work in a country, or your recipient's use of the covered work in a country, would infringe one or more
    identifiable patents in that country that you have reason to believe are valid.</p>

<p>If, pursuant to or in connection with a single transaction or arrangement, you convey, or propagate by procuring
    conveyance of, a covered work, and grant a patent license to some of the parties receiving the covered work
    authorizing them to use, propagate, modify or convey a specific copy of the covered work, then the patent license
    you grant is automatically extended to all recipients of the covered work and works based on it.

<p>A patent license is “discriminatory” if it does not include within the scope of its coverage, prohibits the exercise
    of, or is conditioned on the non-exercise of one or more of the rights that are specifically granted under this
    License. You may not convey a covered work if you are a party to an arrangement with a third party that is in the
    business of distributing software, under which you make payment to the third party based on the extent of your
    activity of conveying the work, and under which the third party grants, to any of the parties who would receive the
    covered work from you, a discriminatory patent license (a) in connection with copies of the covered work conveyed by
    you (or copies made from those copies), or (b) primarily for and in connection with specific products or
    compilations that contain the covered work, unless you entered into that arrangement, or that patent license was
    granted, prior to 28 March 2007.</p>

<p>Nothing in this License shall be construed as excluding or limiting any implied license or other defenses to
    infringement that may otherwise be available to you under applicable patent law.</p>

<p>12. No Surrender of Others' Freedom.</p>
<p>If conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of
    this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as
    to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a
    consequence you may not convey it at all. For example, if you agree to terms that obligate you to collect a royalty
    for further conveying from those to whom you convey the Program, the only way you could satisfy both those terms and
    this License would be to refrain entirely from conveying the Program.</p>

<p>13. Use with the GNU Affero General Public License.</p>
<p>Notwithstanding any other provision of this License, you have permission to link or combine any covered work with a
    work licensed under version 3 of the GNU Affero General Public License into a single combined work, and to convey
    the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the
    special requirements of the GNU Affero General Public License, section 13, concerning interaction through a network
    will apply to the combination as such.</p>

<p>14. Revised Versions of this License.</p>
<p>The Free Software Foundation may publish revised and/or new versions of the GNU General Public License from time to
    time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new
    problems or concerns.</p>

<p>Each version is given a distinguishing version number. If the Program specifies that a certain numbered version of
    the GNU General Public License “or any later version” applies to it, you have the option of following the terms and
    conditions either of that numbered version or of any later version published by the Free Software Foundation. If the
    Program does not specify a version number of the GNU General Public License, you may choose any version ever
    published by the Free Software Foundation.</p>

<p>If the Program specifies that a proxy can decide which future versions of the GNU General Public License can be used,
    that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the
    Program.</p>

<p>Later license versions may give you additional or different permissions. However, no additional obligations are
    imposed on any author or copyright holder as a result of your choosing to follow a later version.</p>

<p>15. Disclaimer of Warranty.</p>
<p>THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN
    WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER
    EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
    PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM
    PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.</p>

<p>16. Limitation of Liability.</p>
<p>IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY
    WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL,
    SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT
    NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
    FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF
    THE POSSIBILITY OF SUCH DAMAGES.</p>

<p>17. Interpretation of Sections 15 and 16.</p>
<p>If the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according
    to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all
    civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of
    the Program in return for a fee.</p>

<p>END OF TERMS AND CONDITIONS</p>

<p>How to Apply These Terms to Your New Programs</p>
<p>If you develop a new program, and you want it to be of the greatest possible use to the public, the best way to
    achieve this is to make it free software which everyone can redistribute and change under these terms.</p>

<p>To do so, attach the following notices to the program. It is safest to attach them to the start of each source file
    to most effectively state the exclusion of warranty; and each file should have at least the “copyright” line and a
    pointer to where the full notice is found.</p>

<p>
    <one line to give the program
    's name and a brief idea of what it
</p>
<p>does.></p>
<p>Copyright (C)
    <year>
        <name of author>
</p>

<p> This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.</p>

<p> This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.</p>

<p> You should have received a copy of the GNU General Public License
    along with this program. If not, see
    <http:
    //www.gnu.org/licenses/>.
</p>
<p> Also add information on how to contact you by electronic and paper mail.</p>

<p> If the program does terminal interaction, make it output a short notice like this when it starts in an interactive
    mode:</p>

<p>
    <program> Copyright (C)
        <year>
            <name of author>
</p>

<p> This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.</p>
<p> This is free software, and you are welcome to redistribute it
    under certain conditions; type `show c' for details.</p>
<p> The hypothetical commands `show w' and `show c' should show the appropriate parts of the General Public License. Of
    course, your program's commands might be different; for a GUI interface, you would use an “about box”.</p>

<p> You should also get your employer (if you work as a programmer) or school, if any, to sign a “copyright disclaimer”
    for the program, if necessary. For more information on this, and how to apply and follow the GNU GPL, see
    <http:
    //www.gnu.org/licenses/>.
</p>

<p> The GNU General Public License does not permit incorporating your program into proprietary programs. If your program
    is a subroutine library, you may consider it more useful to permit linking proprietary applications with the
    library. If this is what you want to do, use the GNU Lesser General Public License instead of this License. But
    first, please read
    <http:
    //www.gnu.org/philosophy/why-not-lgpl.html>.
</p>

<h3>Written Offer</h3>
<p>This product contains software whose rights holders license it on the terms of the GNU General Public License,
    version 2 (GPLv2) and/or other open source software licenses. We will provide you and any third party with the
    source code of the software licensed under an open source software license if you send us a written request by mail
    or email to the following addresses:<br/>
    <a href="mailto:mobile@huawei.com" style="color: #005bba;text-decoration:none">mobile@huawei.com</a><br/>
    <br/>
    detailing the name of the product and the firmware version for which you need the source code and indicating how we
    can
    contact you.<br/>
    Please note you need to make a payment before you obtain the complete Corresponding Source Code from us. For how
    much
    you will pay and how we will deliver the complete Corresponding Source Code to you, we will further discuss it by
    mail
    or email.<br/>
    This offer is valid to anyone in receipt of this information.<br/>
    <br/>
    <b style="font-family:Times New Roman"><span style="text-transform:uppercase">THIS OFFER IS VALID FOR THREE YEARS FROM THE MOMENT WE DISTRIBUTED THE PRODUCT OR FIRMWARE.</span></b>
</p>
</p>

<h3>Software: okhttp 4.10.0</h3>
<p><strong>Copyright notice:</strong><br/>
    Copyright (c) 2015 the original author or authors<br/>
    Copyright (c) 2019 Square, Inc.<br/>
    Copyright (c) 2019 Square, Inc.<br/>
    Copyright (c) 2020 Square, Inc.<br/>
    Copyright (c) 2018 Square, Inc.<br/>
    Copyright (c) 2012 Google Inc.<br/>
    Copyright (c) 2011 Google Inc.<br/>
    Copyright (c) 2013 Square, Inc.<br/>
    Copyright (c) 2014 Square, Inc.<br/>
    Copyright (c) 2012 Square, Inc.<br/>
    Copyright (c) 2011 The Android Open Source Project<br/>
    Copyright (c) 2012 The Android Open Source Project<br/>
    Copyright (c) 2015 Square, Inc.<br/>
    Copyright (c) 2010 The Android Open Source Project<br/>
    Copyright (c) 2017 Square, Inc.<br/>
    Copyright (c) 2016 Square, Inc.<br/>
    Copyright (c) 2013 Twitter, Inc.<br/>
    Copyright (c) 2016 Google Inc.<br/>
    Copyright (c) 2019 Square Inc.<br/>
    Copyright (c) 2014 Square Inc.<br/>
    Copyright (c) 2011 The Guava Authors<br/>
    Copyright (c) 2009 The Android Open Source Project<br/>
    Copyright (c) 2013 The Android Open Source Project<br/>
    Copyright (c) zbar http h:example.com<br/>
    Copyright (c) 2016 The Netty Project<br/>
    Copyright (c) 2006 Entrust, Inc.<br/>
    Copyright (c) 2009 Entrust, Inc.<br/>
    Copyright (c) 2014 Entrust, Inc.<br/>
    Copyright (c) 2006 Entrust<br/>
    <strong>License: Apache License V2.0</strong><br/>
    <a href="#apache" style="color: #005bba;text-decoration:none">Please see above.</a><br/>
<p><strong>License: Creative Commons Legal CodeCC0 1.0 Universal</strong></p>
<p id="cclc1u">Creative Commons Legal Code</p>

<p>CC0 1.0 Universal

    CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
    LEGAL SERVICES. DISTRIBUTION OF THIS DOCUMENT DOES NOT CREATE AN
    ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS
    INFORMATION ON AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES
    REGARDING THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS
    PROVIDED HEREUNDER, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING FROM
    THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS PROVIDED
    HEREUNDER.</p>

<p>Statement of Purpose</p>

<p>The laws of most jurisdictions throughout the world automatically confer
    exclusive Copyright and Related Rights (defined below) upon the creator
    and subsequent owner(s) (each and all, an "owner") of an original work of
    authorship and/or a database (each, a "Work").</p>

<p>Certain owners wish to permanently relinquish those rights to a Work for
    the purpose of contributing to a commons of creative, cultural and
    scientific works ("Commons") that the public can reliably and without fear
    of later claims of infringement build upon, modify, incorporate in other
    works, reuse and redistribute as freely as possible in any form whatsoever
    and for any purposes, including without limitation commercial purposes.
    These owners may contribute to the Commons to promote the ideal of a free
    culture and the further production of creative, cultural and scientific
    works, or to gain reputation or greater distribution for their Work in
    part through the use and efforts of others.</p>

<p>For these and/or other purposes and motivations, and without any
    expectation of additional consideration or compensation, the person
    associating CC0 with a Work (the "Affirmer"), to the extent that he or she
    is an owner of Copyright and Related Rights in the Work, voluntarily
    elects to apply CC0 to the Work and publicly distribute the Work under its
    terms, with knowledge of his or her Copyright and Related Rights in the
    Work and the meaning and intended legal effect of CC0 on those rights.</p>

<p>1. Copyright and Related Rights. A Work made available under CC0 may be
    protected by copyright and related or neighboring rights ("Copyright and
    Related Rights"). Copyright and Related Rights include, but are not
    limited to, the following:

    i. the right to reproduce, adapt, distribute, perform, display,
    communicate, and translate a Work;
    ii. moral rights retained by the original author(s) and/or performer(s);
    iii. publicity and privacy rights pertaining to a person's image or
    likeness depicted in a Work;
    iv. rights protecting against unfair competition in regards to a Work,
    subject to the limitations in paragraph 4(a), below;
    v. rights protecting the extraction, dissemination, use and reuse of data
    in a Work;
    vi. database rights (such as those arising under Directive 96/9/EC of the
    European Parliament and of the Council of 11 March 1996 on the legal
    protection of databases, and under any national implementation
    thereof, including any amended or successor version of such
    directive); and
    vii. other similar, equivalent or corresponding rights throughout the
    world based on applicable law or treaty, and any national
    implementations thereof.</p>

<p>2. Waiver. To the greatest extent permitted by, but not in contravention
    of, applicable law, Affirmer hereby overtly, fully, permanently,
    irrevocably and unconditionally waives, abandons, and surrenders all of
    Affirmer's Copyright and Related Rights and associated claims and causes
    of action, whether now known or unknown (including existing as well as
    future claims and causes of action), in the Work (i) in all territories
    worldwide, (ii) for the maximum duration provided by applicable law or
    treaty (including future time extensions), (iii) in any current or future
    medium and for any number of copies, and (iv) for any purpose whatsoever,
    including without limitation commercial, advertising or promotional
    purposes (the "Waiver"). Affirmer makes the Waiver for the benefit of each
    member of the public at large and to the detriment of Affirmer's heirs and
    successors, fully intending that such Waiver shall not be subject to
    revocation, rescission, cancellation, termination, or any other legal or
    equitable action to disrupt the quiet enjoyment of the Work by the public
    as contemplated by Affirmer's express Statement of Purpose.</p>

<p>3. Public License Fallback. Should any part of the Waiver for any reason
    be judged legally invalid or ineffective under applicable law, then the
    Waiver shall be preserved to the maximum extent permitted taking into
    account Affirmer's express Statement of Purpose. In addition, to the
    extent the Waiver is so judged Affirmer hereby grants to each affected
    person a royalty-free, non transferable, non sublicensable, non exclusive,
    irrevocable and unconditional license to exercise Affirmer's Copyright and
    Related Rights in the Work (i) in all territories worldwide, (ii) for the
    maximum duration provided by applicable law or treaty (including future
    time extensions), (iii) in any current or future medium and for any number
    of copies, and (iv) for any purpose whatsoever, including without
    limitation commercial, advertising or promotional purposes (the
    "License"). The License shall be deemed effective as of the date CC0 was
    applied by Affirmer to the Work. Should any part of the License for any
    reason be judged legally invalid or ineffective under applicable law, such
    partial invalidity or ineffectiveness shall not invalidate the remainder
    of the License, and in such case Affirmer hereby affirms that he or she
    will not (i) exercise any of his or her remaining Copyright and Related
    Rights in the Work or (ii) assert any associated claims and causes of
    action with respect to the Work, in either case contrary to Affirmer's
    express Statement of Purpose.</p>

<p>4. Limitations and Disclaimers.

    a. No trademark or patent rights held by Affirmer are waived, abandoned,
    surrendered, licensed or otherwise affected by this document.
    b. Affirmer offers the Work as-is and makes no representations or
    warranties of any kind concerning the Work, express, implied,
    statutory or otherwise, including without limitation warranties of
    title, merchantability, fitness for a particular purpose, non
    infringement, or the absence of latent or other defects, accuracy, or
    the present or absence of errors, whether or not discoverable, all to
    the greatest extent permissible under applicable law.
    c. Affirmer disclaims responsibility for clearing rights of other persons
    that may apply to the Work or any use thereof, including without
    limitation any person's Copyright and Related Rights in the Work.
    Further, Affirmer disclaims responsibility for obtaining any necessary
    consents, permissions or other rights required for any use of the
    Work.
    d. Affirmer understands and acknowledges that Creative Commons is not a
    party to this document and has no duty or obligation with respect to
    this CC0 or use of the Work.</p>
<p><strong>License: Mozilla Public License (MPL) V2.0</strong></p>
<p id="mplv2">MOZILLA PUBLIC LICENSE</p>
<p>VERSION 2.0</p>
<p>1. DEFINITIONS</p>
<p>1.1. “Contributor”</p>
<p>means each individual or legal entity that creates, contributes to the creation of, or owns
    Covered Software.</p>
<p>1.2. “Contributor Version”</p>
<p>means the combination of the Contributions of others (if any) used by a Contributor and that
    particular Contributor’s Contribution.</p>
<p>1.3. “Contribution”</p>
<p>means Covered Software of a particular Contributor.</p>
<p>1.4. “Covered Software”</p>
<p>means Source Code Form to which the initial Contributor has attached the notice in Exhibit A, the
    Executable Form of such Source Code Form, and Modifications of such Source Code Form, in each
    case including portions thereof.</p>
<p>1.5. “Incompatible With Secondary Licenses”</p>
<p>means
    a. that the initial Contributor has attached the notice described in Exhibit B to the Covered
    Software; or
    b. that the Covered Software was made available under the terms of version 1.1 or earlier of the
    License, but not also under the terms of a Secondary License.</p>
<p>1.6. “Executable Form”</p>
<p>means any form of the work other than Source Code Form.</p>
<p>1.7. “Larger Work”</p>
<p>means a work that combines Covered Software with other material, in a separate file or files,
    that is not Covered Software.</p>
<p>1.8. “License”</p>
<p>means this document.</p>
<p>1.9. “Licensable”</p>
<p>means having the right to grant, to the maximum extent possible, whether at the time of the
    initial grant or subsequently, any and all of the rights conveyed by this License.</p>
<p>1.10. “Modifications”</p>
<p>means any of the following:
    a. any file in Source Code Form that results from an addition to, deletion from, or modification
    of the contents of Covered Software; or
    b. any new file in Source Code Form that contains any Covered Software.</p>
<p>1.11. “Patent Claims” of a Contributor</p>
<p>means any patent claim(s), including without limitation, method, process, and apparatus claims,
    in any patent Licensable by such Contributor that would be infringed, but for the grant of the
    License, by the making, using, selling, offering for sale, having made, import, or transfer of
    either its Contributions or its Contributor Version.</p>
<p>1.12. “Secondary License”</p>
<p>means either the GNU General Public License, Version 2.0, the GNU Lesser General Public License,
    Version 2.1, the GNU Affero General Public License, Version 3.0, or any later versions of those
    licenses.</p>
<p>1.13. “Source Code Form”</p>
<p>means the form of the work preferred for making modifications.</p>
<p>1.14. “You” (or “Your”)</p>
<p>means an individual or a legal entity exercising rights under this License. For legal entities,
    “You” includes any entity that controls, is controlled by, or is under common control with You.
    For purposes of this definition, “control” means (a) the power, direct or indirect, to cause the
    direction or management of such entity, whether by contract or otherwise, or (b) ownership of
    more than fifty percent (50%) of the outstanding shares or beneficial ownership of such
    entity.</p>
<p>2. LICENSE GRANTS AND CONDITIONS</p>
<p>2.1. GRANTS</p>
<p>Each Contributor hereby grants You a world-wide, royalty-free, non-exclusive license:
    a. under intellectual property rights (other than patent or trademark) Licensable by such
    Contributor to use, reproduce, make available, modify, display, perform, distribute, and
    otherwise exploit its Contributions, either on an unmodified basis, with Modifications, or as
    part of a Larger Work; and
    b. under Patent Claims of such Contributor to make, use, sell, offer for sale, have made,
    import, and otherwise transfer either its Contributions or its Contributor Version.</p>
<p>2.2. EFFECTIVE DATE</p>
<p>The licenses granted in Section 2.1 with respect to any Contribution become effective for each
    Contribution on the date the Contributor first distributes such Contribution.</p>
<p>2.3. LIMITATIONS ON GRANT SCOPE</p>
<p>The licenses granted in this Section 2 are the only rights granted under this License. No
    additional rights or licenses will be implied from the distribution or licensing of Covered
    Software under this License. Notwithstanding Section 2.1(b) above, no patent license is granted
    by a Contributor:
    a. for any code that a Contributor has removed from Covered Software; or
    b. for infringements caused by: (i) Your and any other third party’s modifications of Covered
    Software, or (ii) the combination of its Contributions with other software (except as part of
    its Contributor Version); or
    c. under Patent Claims infringed by Covered Software in the absence of its Contributions.</p>
<p>This License does not grant any rights in the trademarks, service marks, or logos of any
    Contributor (except as may be necessary to comply with the notice requirements in Section
    3.4).</p>
<p>2.4. SUBSEQUENT LICENSES</p>
<p>No Contributor makes additional grants as a result of Your choice to distribute the Covered
    Software under a subsequent version of this License (see Section 10.2) or under the terms of a
    Secondary License (if permitted under the terms of Section 3.3).</p>
<p>2.5. REPRESENTATION</p>
<p>Each Contributor represents that the Contributor believes its Contributions are its original
    creation(s) or it has sufficient rights to grant the rights to its Contributions conveyed by
    this License.</p>
<p>2.6. FAIR USE</p>
<p>This License is not intended to limit any rights You have under applicable copyright doctrines of
    fair use, fair dealing, or other equivalents.</p>
<p>2.7. CONDITIONS</p>
<p>Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in Section 2.1.</p>
<p>3. RESPONSIBILITIES</p>
<p>3.1. DISTRIBUTION OF SOURCE FORM</p>
<p>All distribution of Covered Software in Source Code Form, including any Modifications that You
    create or to which You contribute, must be under the terms of this License. You must inform
    recipients that the Source Code Form of the Covered Software is governed by the terms of this
    License, and how they can obtain a copy of this License. You may not attempt to alter or
    restrict the recipients’ rights in the Source Code Form.</p>
<p>3.2. DISTRIBUTION OF EXECUTABLE FORM</p>
<p>If You distribute Covered Software in Executable Form then:
    a. such Covered Software must also be made available in Source Code Form, as described in
    Section 3.1, and You must inform recipients of the Executable Form how they can obtain a copy of
    such Source Code Form by reasonable means in a timely manner, at a charge no more than the cost
    of distribution to the recipient; and
    b. You may distribute such Executable Form under the terms of this License, or sublicense it
    under different terms, provided that the license for the Executable Form does not attempt to
    limit or alter the recipients’ rights in the Source Code Form under this License.</p>
<p>3.3. DISTRIBUTION OF A LARGER WORK</p>
<p>You may create and distribute a Larger Work under terms of Your choice, provided that You also
    comply with the requirements of this License for the Covered Software. If the Larger Work is a
    combination of Covered Software with a work governed by one or more Secondary Licenses, and the
    Covered Software is not Incompatible With Secondary Licenses, this License permits You to
    additionally distribute such Covered Software under the terms of such Secondary License(s), so
    that the recipient of the Larger Work may, at their option, further distribute the Covered
    Software under the terms of either this License or such Secondary License(s).</p>
<p>3.4. NOTICES</p>
<p>You may not remove or alter the substance of any license notices (including copyright notices,
    patent notices, disclaimers of warranty, or limitations of liability) contained within the
    Source Code Form of the Covered Software, except that You may alter any license notices to the
    extent required to remedy known factual inaccuracies.</p>
<p>3.5. APPLICATION OF ADDITIONAL TERMS</p>
<p>You may choose to offer, and to charge a fee for, warranty, support, indemnity or liability
    obligations to one or more recipients of Covered Software. However, You may do so only on Your
    own behalf, and not on behalf of any Contributor. You must make it absolutely clear that any
    such warranty, support, indemnity, or liability obligation is offered by You alone, and You
    hereby agree to indemnify every Contributor for any liability incurred by such Contributor as a
    result of warranty, support, indemnity or liability terms You offer. You may include additional
    disclaimers of warranty and limitations of liability specific to any jurisdiction.</p>
<p>4. INABILITY TO COMPLY DUE TO STATUTE OR REGULATION</p>
<p>If it is impossible for You to comply with any of the terms of this License with respect to some
    or all of the Covered Software due to statute, judicial order, or regulation then You must: (a)
    comply with the terms of this License to the maximum extent possible; and (b) describe the
    limitations and the code they affect. Such description must be placed in a text file included
    with all distributions of the Covered Software under this License. Except to the extent
    prohibited by statute or regulation, such description must be sufficiently detailed for a
    recipient of ordinary skill to be able to understand it.</p>
<p>5. TERMINATION</p>
<p>5.1. The rights granted under this License will terminate automatically if You fail to comply
    with any of its terms. However, if You become compliant, then the rights granted under this
    License from a particular Contributor are reinstated (a) provisionally, unless and until such
    Contributor explicitly and finally terminates Your grants, and (b) on an ongoing basis, if such
    Contributor fails to notify You of the non-compliance by some reasonable means prior to 60 days
    after You have come back into compliance. Moreover, Your grants from a particular Contributor
    are reinstated on an ongoing basis if such Contributor notifies You of the non-compliance by
    some reasonable means, this is the first time You have received notice of non-compliance with
    this License from such Contributor, and You become compliant prior to 30 days after Your receipt
    of the notice.
    5.2. If You initiate litigation against any entity by asserting a patent infringement claim
    (excluding declaratory judgment actions, counter-claims, and cross-claims) alleging that a
    Contributor Version directly or indirectly infringes any patent, then the rights granted to You
    by any and all Contributors for the Covered Software under Section 2.1 of this License shall
    terminate.
    5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user license
    agreements (excluding distributors and resellers) which have been validly granted by You or Your
    distributors under this License prior to termination shall survive termination.</p>
<p>6. DISCLAIMER OF WARRANTY</p>
<p>Covered Software is provided under this License on an “as is” basis, without warranty of any
    kind, either expressed, implied, or statutory, including, without limitation, warranties that
    the Covered Software is free of defects, merchantable, fit for a particular purpose or
    non-infringing. The entire risk as to the quality and performance of the Covered Software is
    with You. Should any Covered Software prove defective in any respect, You (not any Contributor)
    assume the cost of any necessary servicing, repair, or correction. This disclaimer of warranty
    constitutes an essential part of this License. No use of any Covered Software is authorized
    under this License except under this disclaimer.</p>
<p>7. LIMITATION OF LIABILITY</p>
<p>Under no circumstances and under no legal theory, whether tort (including negligence), contract,
    or otherwise, shall any Contributor, or anyone who distributes Covered Software as permitted
    above, be liable to You for any direct, indirect, special, incidental, or consequential damages
    of any character including, without limitation, damages for lost profits, loss of goodwill, work
    stoppage, computer failure or malfunction, or any and all other commercial damages or losses,
    even if such party shall have been informed of the possibility of such damages. This limitation
    of liability shall not apply to liability for death or personal injury resulting from such
    party’s negligence to the extent applicable law prohibits such limitation. Some jurisdictions do
    not allow the exclusion or limitation of incidental or consequential damages, so this exclusion
    and limitation may not apply to You.</p>
<p>8. LITIGATION</p>
<p>Any litigation relating to this License may be brought only in the courts of a jurisdiction where
    the defendant maintains its principal place of business and such litigation shall be governed by
    laws of that jurisdiction, without reference to its conflict-of-law provisions. Nothing in this
    Section shall prevent a party’s ability to bring cross-claims or counter-claims.</p>
<p>9. MISCELLANEOUS</p>
<p>This License represents the complete agreement concerning the subject matter hereof. If any
    provision of this License is held to be unenforceable, such provision shall be reformed only to
    the extent necessary to make it enforceable. Any law or regulation which provides that the
    language of a contract shall be construed against the drafter shall not be used to construe this
    License against a Contributor.</p>
<p>10. VERSIONS OF THE LICENSE</p>
<p>10.1. NEW VERSIONS</p>
<p>Mozilla Foundation is the license steward. Except as provided in Section 10.3, no one other than
    the license steward has the right to modify or publish new versions of this License. Each
    version will be given a distinguishing version number.</p>
<p>10.2. EFFECT OF NEW VERSIONS</p>
<p>You may distribute the Covered Software under the terms of the version of the License under which
    You originally received the Covered Software, or under the terms of any subsequent version
    published by the license steward.</p>
<p>10.3. MODIFIED VERSIONS</p>
<p>If you create software not governed by this License, and you want to create a new license for
    such software, you may create and use a modified version of this License if you rename the
    license and remove any references to the name of the license steward (except to note that such
    modified license differs from this License).</p>
<p>10.4. DISTRIBUTING SOURCE CODE FORM THAT IS INCOMPATIBLE WITH SECONDARY LICENSES</p>
<p>If You choose to distribute Source Code Form that is Incompatible With Secondary Licenses under
    the terms of this version of the License, the notice described in Exhibit B of this License must
    be attached.</p>
<p>EXHIBIT A - SOURCE CODE FORM LICENSE NOTICE</p>
<p>This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of
    the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.
    If it is not possible or desirable to put the notice in a particular file, then You may include
    the notice in a location (such as a LICENSE file in a relevant directory) where a recipient
    would be likely to look for such a notice.
    You may add additional accurate notices of copyright ownership.</p>
<p>EXHIBIT B - “INCOMPATIBLE WITH SECONDARY LICENSES” NOTICE</p>
<p>This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public
    License, v. 2.0.</p>

</p>


</body>
</html>
